//Prividing names to the nodes of the tree
const Data = {
  "name": "Primates",
  "value": 9,
  "type": "brown",
  "level": "red",
  "children": [
    {  
      "name": "Strepsirrhini",
      "value": 9,
      "type": "brown",
      "level": "lightgreen",
      "children": [
        //Naming the sub unit of the Strepsirrhini
        {
          "name": "Lemuroida",
          "value": 9,
          "type": "yellow",
          "level": "lightgreen",
          "children":[
            //Naming the sub units of Lemuroida
            {
              "name": "Ring-tailed lemurs",
              "value": 9,
               "type": "orange",
               "level": "lightgreen",
            },
            {
              "name": "Indris",
              "value": 9,
               "type": "orange",
               "level": "lightgreen",
            },
            {
              "name": "Mouse lemurs",
              "value": 9,
               "type": "orange",
               "level": "lightgreen",
            },
      ]
  },
        {
          // Naming another sub unit of 'Strepsirrhini'
          "name": "Lorisoida",
          "value": 9,
          "type": "yellow",
          "level": "lightgreen",
           "children": [
           {
             //Naming the sub units of 'Lorisoida'
          "name": "Larises",
          "value": 9,
          "type": "orange",
          "level": "lightgreen",
          },
         {
          "name": "Pottos",
          "value": 9,
          "type": "orange",
          "level": "lightgreen"
        }
      ]
    },
        ]
    },
    {
      //Naming the second sub unit of 'Primates'
      "name": "Haplorrhini",
      "value": 9,
      "type": "brown",
      "level": "skyblue",
      "children": [
         {
           
      //Naming the first sub unit of Haplorrihini and its sub units
          "name": "Tarsiiformes",
          "value": 9,
          "type": "yellow",
          "level": "skyblue",
          "children":[
            {
              "name": "Tarisers",
              "value": 9,
               "type": "orange",
               "level": "skyblue",
            }, 
      ]
    },
         {
           //Naming the second sub unit of Haplorrhini and its children
          "name": "Platyrrhini",
          "value": 9,
          "type": "yellow",
          "level": "skyblue",
           "children": [
           {
          "name": "Capuchin monkeys",
          "value": 9,
          "type": "orange",
          "level": "skyblue",
          },
         {
          "name": "Owl monkeys",
          "value": 9,
          "type": "orange",
          "level": "skyblue"
        },
             {
          "name": "Spider monkeys",
          "value": 9,
          "type": "orange",
          "level": "skyblue"
        }
      ]
    },
        {
          // Naming the third sub unit of Haplorrhini and its sub units
          "name": "Catarrhini",
          "value": 9,
          "type": "yellow",
          "level": "skyblue",
           "children": [
           {
          "name": "Langurs",
          "value": 9,
          "type": "orange",
          "level": "skyblue",
          },
         {
          "name": "Guenous",
          "value": 9,
          "type": "orange",
          "level": "skyblue"
        },
          {
          "name": "Baboons",
          "value": 9,
          "type": "orange",
          "level": "skyblue"
        },
        {
          "name": "Gorillas",
          "value": 9,
          "type": "orange",
          "level": "skyblue"
        },
      ]
    },
  ]
    },
     
    ]
};

// Defining the width,height and margin of the tree
const margin = {top: 10, right: 250, bottom:200, left: 200},
      width  = 850 - margin.left - margin.right,
      height = 650 - margin.top - margin.bottom;

// Defining the height , width of a tree.
const tree = d3.tree().size([height, width]);

//Assigning the heirarchical structure to the data to classify the data
let nodes = d3.hierarchy(Data, node => node.children);

// Providing the data connection for nodes to their respective position in the tree
nodes = tree(nodes);

// Adding an svg element
const svg = d3.select("body").append("svg")
        .attr("width", width + margin.left + margin.right)
        .attr("height", height + margin.top + margin.bottom),
      g = svg.append("g")//appends group
        .attr("transform",
            "translate(" + margin.left + "," + margin.top + ")");

// Defining the links between nodes
const link = g.selectAll(".link")
    .data( nodes.descendants().slice(1))
  .enter().append("path")
    .attr("class", "link")
    .style("stroke", d => d.data.level)
    .attr("d", d => {
       return "M" + d.y + "," + d.x
         + "C" + (d.y + d.parent.y) / 2 + "," + d.x
         + " " + (d.y + d.parent.y) / 2 + "," + d.parent.x
         + " " + d.parent.y + "," + d.parent.x;
       });

// declaring a group for each node present in the tree
const node = g.selectAll(".node")
    .data(nodes.descendants())
    .enter().append("g")
    .attr("class", d => "node" + (d.children ? " node--internal" : " node--leaf"))
    .attr("transform", d => "translate(" + d.y + "," + d.x + ")");

// Defining the shape of the node as circle
node.append("circle")
  .attr("r", d => d.data.value)
  .style("stroke", d => d.data.type)
  .style("fill", d => d.data.level);
  
// adding a new node to the list
node.append("text")
  .attr("dy", ".60em")
  .attr("x", d => d.children ? (d.data.value + 5) * -1 : d.data.value + 5)
  .attr("y", d => d.children && d.depth !== 0 ? -(d.data.value + 5) : d)
  .style("text-anchor", d => d.children ? "end" : "start")
  .text(d => d.data.name);